\documentclass[a4paper, trou]{tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Data science}
\ddmodulenumber{Starting with numpy et matplotlib}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien




\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  

\newmplexoEN{01}{Display a curve $y = cos(x)$}

\noindent The aim of this tutorial is to familiarize you with the
\texttt{matplotlib} and \texttt{numpy} data processing libraries. In
this tutorial, you'll see how to plot the curves $f_{1} = cos(x)$ and
$f_{2} = sin(x)$.

\begin{center}
  \includegraphics[width=\linewidth]{sin-cos.pdf}
\end{center}


\subsection*{Part 1 : data creation  (without numpy)}
\begin{info}
  In this section, you will create the $x$ and $y$ dataset.  The
  variable \texttt{x} will be a list of numbers in the interval
  $[0, 10]$, while variable \texttt{y} will be the application of the
  $cos$ function to the list \texttt{x}.
\end{info}


\begin{task}
  Create an empty python list. Name this list using the variable \texttt{x}.
\end{task}

\begin{task}
  Using the \texttt{append(...)}, function, add values to this list to
  obtain the following list \texttt{[0., 0.1, 0.2, 0.3, ..., 9.9]}.
\end{task}

\begin{info}
  The correction for this part is given by \dltutompl{01}{part-1a.py}
\end{info}

\begin{task}
  Create a list \texttt{y}, of the same size as \texttt{x}, which
  applies the $cos$ function for each of the values of \texttt{x}.
\end{task}

\begin{info}
  The correction for this part is given by \dltutompl{01}{part-1b.py}
\end{info}

\subsection*{Part 2 : displaying the curve y = f(x)}

\begin{info}
In this section, you will graph the curve $y = f(x)$ using the \texttt{matplotlib} module.
\end{info}

\begin{task}
  Using this
  \href{https://www.w3schools.com/python/matplotlib\_plotting.asp}{documention},
  plot \texttt{x} as a function of \texttt{y} with
  \texttt{matplotlib}.
\end{task}

\begin{task}
  Add the title and names to the axes.
\end{task}

\begin{info}
  The correction for this part is given by \dltutompl{01}{part-2.py}
\end{info}

\subsection*{Part 3 : data creation with numpy}

\begin{info}
  In this section, you will learn how to create \texttt{x}
  and \texttt{y} arrays with the \texttt{numpy} module.
  Here, you'll do the same thing as in part 1.
  However, \texttt{numpy} arrays are far more efficient
  than python lists for processing numerical data!
\end{info}


\begin{task}
  Using the
  \href{https://numpy.org/doc/stable/reference/generated/numpy.linspace.html}{\texttt{linspace()}}
  function of the \texttt{numpy} module, re-generate the array \texttt{x = [0., 0.1, 0.2, 0.3, ..., 9.9]} 
\end{task}

\begin{task}
  Using the \href{https://numpy.org/doc/stable/reference/generated/numpy.cos.html}{\texttt{cos()}} function of the 
  \texttt{numpy} module, re-generate the \texttt{y} array.
\end{task}

\begin{task}
  Plot the function \texttt{y = cos(x)} again with \texttt{matplotlib}
\end{task}

\begin{info}
  The correction for this part is given by \dltutompl{01}{part-3.py}
\end{info}

\newpage
\subsection*{Part 4: going further}


\begin{info}
  In this section, you'll learn how to display multiple curves on the
  same graph, how to add legends, etc...  \texttt{Matplotlib} offers
  so many options that it's impossible to be exhaustive.
\end{info}

\begin{task}
  Add the curve \texttt{y = sin(x)} to the previous graph. You should
  obtain the following image.
\end{task}

\begin{center}
  \includegraphics[width=\linewidth]{sin-cos.png}
\end{center}

\begin{task}
  With the help of this
  \href{https://www.geeksforgeeks.org/matplotlib-pyplot-legend-in-python/}{documentation},
  add legends and draw the curve \texttt{y = sin(x)} in dashed line. You should
  obtain the following image.
\end{task}

\begin{center}
  \includegraphics[width=\linewidth]{sin-cos1.png}
\end{center}

\begin{info}
  The correction for this part is given by \dltutompl{01}{part-4.py}
\end{info}


\begin{task}
  To go a step further, you can try plotting the function $f(x) = sin(x)^2 + cos(x)^2$
\end{task}

\subsection*{In conclusion}

\texttt{matplotlib} et \texttt{numpy} are extremely powerful modules
that are widely used in data science. The possibilities offered by
these two modules are so numerous that it's impossible to be
exhaustive in this course. My advice, if you want to make a new graph,
is to try and find a Python code (there are plenty of resources on the
Internet) which to what you want to do and modify it to suit your own
needs. For example, you can take a look at the
\href{https://matplotlib.org/stable/gallery/index.html}{matplotlib gallery},
which provides access to a wealth of source code.
\end{document}
